"use strict";

exports.fiber = fiber;

var _posterus = require("./posterus");

function fiber(n) {
    validate(n, isIterator);
    var e = new _posterus.Future();
    var t = void 0;
    function onDone(i, o) {
        if (i) e.settle(maybeToFuture(i));else e.settle(undefined, maybeToFuture(o));
        if (t) t.deinit();
        t = undefined;
        n.return();
    }
    function iterNext(e) {
        try {
            onIterNext(n.next(e));
        } catch (n) {
            onDone(n);
        }
    }
    function iterThrow(e) {
        try {
            onIterNext(n.throw(e));
        } catch (n) {
            onDone(n);
        }
    }
    function onIterNext(n) {
        var e = n.value,
            i = n.done;
        if (i) {
            onDone(undefined, e);
            return;
        }
        e = maybeToFuture(e);
        if (_posterus.isFuture(e)) {
            t = e.map(onPendingDone);
            return;
        }
        iterNext(e);
    }
    function onPendingDone(n, e) {
        t = undefined;
        if (n) iterThrow(n);else iterNext(e);
    }
    iterNext();
    return e.finally(onDone);
};

function maybeToFuture(n) {
    return _posterus.isFuture(n) ? n : isIterator(n) ? fiber(n) : isPromise(n) ? _posterus.Future.fromPromise(n) : n;
}

function isIterator(n) {
    return isObject(n) && isFunction(n.next) && isFunction(n.return) && isFunction(n.throw);
}

function isPromise(n) {
    return isObject(n) && isFunction(n.then) && isFunction(n.catch);
}

function isFunction(n) {
    return typeof n === "function";
}

function isObject(n) {
    return n != null && typeof n === "object";
}

function validate(n, e) {
    if (!e(n)) throw Error("Expected " + n + " to satisfy test " + e.name);
}